// Copyright 2024 Universidad Politecnica de Madrid (UPM)
// Authors: Santiago Tapia-Fernández
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

// --------------------------------------------------------------
//     ATTENTION:    DO NOT EDIT!!
// --------------------------------------------------------------
// This file has been automatically generated by Archetypes.
// Any manual changes will be overwritten the next time the file
// is regenerated.
//
// Archetype was `arty_basic_node' version 1.0.0
// Generation datetime: 2025-03-04 21:10:13.803072
// --------------------------------------------------------------


#ifndef __arty_example_alternate_positive_inputs_hpp__
#define __arty_example_alternate_positive_inputs_hpp__

#include <memory>
#include "rclcpp/rclcpp.hpp"

#include "std_srvs/srv/set_bool.hpp"

namespace arty_example_alternate_positive
{

struct inputs
{
  // [TOPICS]

  // [PARAMETERS]
};

struct responses
{
  // [CLIENT SERVICES]
  std_srvs::srv::SetBool::Response::SharedPtr only_positive;
};


class only_positive_wrapper : public std_srvs::srv::SetBool::Request::SharedPtr
{
public:
	only_positive_wrapper() :
	std_srvs::srv::SetBool::Request::SharedPtr(std::make_shared<std_srvs::srv::SetBool::Request>()) {
        // Initialize the SharedPtr
    }

	using CallbackType = std::function<void(std_srvs::srv::SetBool::Request::SharedPtr&)>;

    void init(CallbackType cb) {
		callback_ = cb;
	}

    void async_request() {
        callback_(*this);
    }

private:
    CallbackType callback_;
};

class outputs
{
public:

	only_positive_wrapper only_positive;
};

}  // namespace arty_example_alternate_positive

#endif  // __arty_example_alternate_positive_inputs_hpp__